  DistributedVector(){}

  DistributedVector(const MpiCart &_mpiCart, int rh)
     : mpiCart(_mpiCart), N(rh-1)
  {
    // global matrix has size (N+1) x (N+1)        
    // compute m and n, such that local matrix has size (-1,m+1) x (-1,n+1)
    m = (N+1) / mpiCart.numRows - 1;
    n = (N+1) / mpiCart.numCols - 1;
    grid.resize(_(-1,m+1),_(-1,n+1));
            
    m0 = (m+1)*mpiCart.row;//row offset
    n0 = (n+1)*mpiCart.col;//col offset
            
    firstRow = (mpiCart.row==0) ? 1 : 0; //first non-zero value 
    firstCol = (mpiCart.col==0) ? 1 : 0; //first non-zero value 
                         
    // types to send rows and cols
    MpiRow = MPI::DOUBLE.Create_contiguous(n+2); 
    MpiRow.Commit();           
    MpiCol = MPI::DOUBLE.Create_vector(m+1, 1, grid.leadingDimension());  
    MpiCol.Commit();
  }
